package net.vtstar.zhongtong.avi.gateway.assembly.job;

import lombok.extern.slf4j.Slf4j;
import net.vtstar.scada.base.equipmgt.domain.Enum.EquipStatusEnum;
import net.vtstar.scada.base.gather.domain.EquipmentData;
import net.vtstar.scada.base.gather.job.GatherJob;
import net.vtstar.zhongtong.avi.gateway.assembly.domain.FocusBoosterOilMachine;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * 助力油加注设备数据采集JOB
 */
@Slf4j
@Component
public class FocusBoosterOilMachineJob extends GatherJob {

    private static final String NAME = "FOCUS_BOOSTER_OIL";

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {

        log.info("JobName: {}", context.getJobDetail().getKey().getName());
        super.gatherByModbus(NAME, FocusBoosterOilMachine.class);
    }

    @Override
    public boolean handleObject(EquipmentData equipmentData) {
        FocusBoosterOilMachine data = (FocusBoosterOilMachine) equipmentData;
        String state = data.getStatus();
        if (state == null || "0".equals(state)) {
            return false;
        }
        if (null == data.getFillingAmount1() && null == data.getFillingSettings()){
            return false;
        }
        equipmentData.setEquipStatus(EquipStatusEnum.RUN);
        return true;
    }

    @Override
    public Object handleValue(String fieldName, Object value) {
        return value;
    }

    @Override
    protected void postHandle(EquipmentData equipmentData) {
        ((FocusBoosterOilMachine)equipmentData).setCreateTime(new Date());
    }

}
